package org.uchile.bdd;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;

public class Utils {
	public static String escapeHTML(String s) {
		if(s==null) return null;
	    StringBuilder out = new StringBuilder(Math.max(16, s.length()));
	    for (int i = 0; i < s.length(); i++) {
	        char c = s.charAt(i);
	        if (c > 127 || c == '"' || c == '<' || c == '>' || c == '&') {
	            out.append("&#");
	            out.append((int) c);
	            out.append(';');
	        } else {
	            out.append(c);
	        }
	    }
	    return out.toString();
	}
	
	public static String resultSetToHtml(ResultSet rs) throws SQLException{
		StringBuilder sb = new StringBuilder();
		ResultSetMetaData md = rs.getMetaData();
		int count = md.getColumnCount();
		sb.append("<table border=1>");
		sb.append("<tr>");
		for (int i=1; i<=count; i++) {
			sb.append("<th>");
			sb.append(Utils.escapeHTML(md.getColumnLabel(i)));
			sb.append("</th>");
		}
		sb.append("</tr>");
		int result = 0;
		while (rs.next()) {
			sb.append("<tr>");
			result++;
			for (int i=1; i<=count; i++) {
				sb.append("<td>");
				sb.append(Utils.escapeHTML(rs.getString(i)));
				sb.append("</td>");
			}
			sb.append("</tr>");
		}
		sb.append("</table>");

		sb.append("<p>Resultados: <b>" + result + "</b></p>");
		
		return sb.toString();
	}
}
